! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.6.0 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 15:42 on 18.11.2015   
! ----------------------------------------------------------------------  
 
 
Module BranchingRatios_SDDM 
 
Use Control 
Use Couplings_SDDM 
Use Model_Data_SDDM 
Use LoopCouplings_SDDM 
Use Fu3Decays_SDDM 
Use Fe3Decays_SDDM 
Use Fd3Decays_SDDM 
Use SUSYDecays_SDDM 
 
Contains 
 
Subroutine CalculateBR(CTBD,fac3,epsI,deltaM,kont,MAh,MAh2,MFd,MFd2,MFe,              & 
& MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,             & 
& MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,ZEL,ZUL,ZW,ZZ,v,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,            & 
& LS1,LS2,Lam,L3,L4,L2,Yu,Yd,Ye,MS2,M12,M22,gPFu,gTFu,BRFu,gPFe,gTFe,BRFe,               & 
& gPFd,gTFd,BRFd,gPhh,gThh,BRhh,gPss,gTss,BRss,gPHI0,gTHI0,BRHI0,gPHIp,gTHIp,BRHIp)

Real(dp), Intent(in) :: epsI, deltaM, fac3 
Integer, Intent(inout) :: kont 
Logical, Intent(in) :: CTBD 
Real(dp),Intent(in) :: g1,g2,g3

Complex(dp),Intent(in) :: LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu(3,3),Yd(3,3),Ye(3,3),MS2,M12,M22

Real(dp),Intent(in) :: MAh,MAh2,MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),Mhh,Mhh2,MHI0,MHI02,            & 
& MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZZ(2,2)

Complex(dp),Intent(in) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp),Intent(in) :: v

Real(dp),Intent(inout) :: gPFu(3,144),gTFu(3),BRFu(3,144),gPFe(3,141),gTFe(3),BRFe(3,141),gPFd(3,144),          & 
& gTFd(3),BRFd(3,144),gPhh(1,38),gThh,BRhh(1,38),gPss(1,3),gTss,BRss(1,3),               & 
& gPHI0(1,6),gTHI0,BRHI0(1,6),gPHIp(1,3),gTHIp,BRHIp(1,3)

Complex(dp) :: cplHiggsPP,cplHiggsGG,cplPseudoHiggsPP,cplPseudoHiggsGG,cplHiggsZZvirt,               & 
& cplHiggsWWvirt

Real(dp) :: gTAh 
Real(dp) :: gFuFucFdFd(3,3,3,3),gFuFdcFeFv(3,3,3,3),gFuFucFeFe(3,3,3,3),gFuFucFuFu(3,3,3,3),      & 
& gFuFucFvFv(3,3,3,3),gFeFecFdFd(3,3,3,3),gFeFecFeFe(3,3,3,3),gFeFecFuFu(3,3,3,3),       & 
& gFeFecFvFv(3,3,3,3),gFeFvcFuFd(3,3,3,3),gFdFdcFdFd(3,3,3,3),gFdFdcFeFe(3,3,3,3),       & 
& gFdFdcFuFu(3,3,3,3),gFdFdcFvFv(3,3,3,3),gFdFucFvFe(3,3,3,3)

Complex(dp) :: coup 
Real(dp) :: vev 
Real(dp) :: gTVZ,gTVWp

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateBR'
 
Write(*,*) "Calculating branching ratios and decay widths" 
gTVWp = gamW 
gTVZ = gamZ 
gPFu = 0._dp 
gTFu = 0._dp 
BRFu = 0._dp 
If (.Not.CTBD) Then 
Call FuTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,           & 
& MHI0,MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,            & 
& ZDL,ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,              & 
& Yd,Ye,MS2,M12,M22,v,gPFu(:,1:9),gTFu,BRFu(:,1:9))

If (Enable3BDecaysF) Then 
If (MaxVal(gTFu).Lt.MaxVal(fac3*Abs(MFu))) Then 
Call FuThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,           & 
& MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,             & 
& ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,Yd,               & 
& Ye,MS2,M12,M22,v,gThh,gTVWp,gTVZ,gFuFucFdFd,gFuFdcFeFv,gFuFucFeFe,gFuFucFuFu,          & 
& gFuFucFvFv,epsI,deltaM,.False.,gTFu,gPFu(:,10:144),BRFu(:,10:144))

Else 
Call FuThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,           & 
& MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,             & 
& ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,Yd,               & 
& Ye,MS2,M12,M22,v,gThh,gTVWp,gTVZ,gFuFucFdFd,gFuFdcFeFv,gFuFucFeFe,gFuFucFuFu,          & 
& gFuFucFvFv,epsI,deltaM,.True.,gTFu,gPFu(:,10:144),BRFu(:,10:144))

End If 
 
End If 
Else 
Call FuThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,           & 
& MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,             & 
& ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,Yd,               & 
& Ye,MS2,M12,M22,v,gThh,gTVWp,gTVZ,gFuFucFdFd,gFuFdcFeFv,gFuFucFeFe,gFuFucFuFu,          & 
& gFuFucFvFv,epsI,deltaM,.False.,gTFu,gPFu(:,10:144),BRFu(:,10:144))

End If 
Do i1=1,3
gTFu(i1) =Sum(gPFu(i1,:)) 
If (gTFu(i1).Gt.0._dp) BRFu(i1,: ) =gPFu(i1,:)/gTFu(i1) 
End Do 
 

gPFe = 0._dp 
gTFe = 0._dp 
BRFe = 0._dp 
If (.Not.CTBD) Then 
Call FeTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,           & 
& MHI0,MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,            & 
& ZDL,ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,              & 
& Yd,Ye,MS2,M12,M22,v,gPFe(:,1:6),gTFe,BRFe(:,1:6))

If (Enable3BDecaysF) Then 
If (MaxVal(gTFe).Lt.MaxVal(fac3*Abs(MFe))) Then 
Call FeThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,           & 
& MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,             & 
& ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,Yd,               & 
& Ye,MS2,M12,M22,v,gThh,gTVWp,gTVZ,gFeFecFdFd,gFeFecFeFe,gFeFecFuFu,gFeFecFvFv,          & 
& gFeFvcFuFd,epsI,deltaM,.False.,gTFe,gPFe(:,7:141),BRFe(:,7:141))

Else 
Call FeThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,           & 
& MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,             & 
& ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,Yd,               & 
& Ye,MS2,M12,M22,v,gThh,gTVWp,gTVZ,gFeFecFdFd,gFeFecFeFe,gFeFecFuFu,gFeFecFvFv,          & 
& gFeFvcFuFd,epsI,deltaM,.True.,gTFe,gPFe(:,7:141),BRFe(:,7:141))

End If 
 
End If 
Else 
Call FeThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,           & 
& MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,             & 
& ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,Yd,               & 
& Ye,MS2,M12,M22,v,gThh,gTVWp,gTVZ,gFeFecFdFd,gFeFecFeFe,gFeFecFuFu,gFeFecFvFv,          & 
& gFeFvcFuFd,epsI,deltaM,.False.,gTFe,gPFe(:,7:141),BRFe(:,7:141))

End If 
Do i1=1,3
gTFe(i1) =Sum(gPFe(i1,:)) 
If (gTFe(i1).Gt.0._dp) BRFe(i1,: ) =gPFe(i1,:)/gTFe(i1) 
End Do 
 

gPFd = 0._dp 
gTFd = 0._dp 
BRFd = 0._dp 
If (.Not.CTBD) Then 
Call FdTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,           & 
& MHI0,MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,            & 
& ZDL,ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,              & 
& Yd,Ye,MS2,M12,M22,v,gPFd(:,1:9),gTFd,BRFd(:,1:9))

If (Enable3BDecaysF) Then 
If (MaxVal(gTFd).Lt.MaxVal(fac3*Abs(MFd))) Then 
Call FdThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,           & 
& MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,             & 
& ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,Yd,               & 
& Ye,MS2,M12,M22,v,gThh,gTVWp,gTVZ,gFdFdcFdFd,gFdFdcFeFe,gFdFdcFuFu,gFdFdcFvFv,          & 
& gFdFucFvFe,epsI,deltaM,.False.,gTFd,gPFd(:,10:144),BRFd(:,10:144))

Else 
Call FdThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,           & 
& MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,             & 
& ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,Yd,               & 
& Ye,MS2,M12,M22,v,gThh,gTVWp,gTVZ,gFdFdcFdFd,gFdFdcFeFe,gFdFdcFuFu,gFdFdcFvFv,          & 
& gFdFucFvFe,epsI,deltaM,.True.,gTFd,gPFd(:,10:144),BRFd(:,10:144))

End If 
 
End If 
Else 
Call FdThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,MHI0,           & 
& MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,ZDL,             & 
& ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,Yd,               & 
& Ye,MS2,M12,M22,v,gThh,gTVWp,gTVZ,gFdFdcFdFd,gFdFdcFeFe,gFdFdcFuFu,gFdFdcFvFv,          & 
& gFdFucFvFe,epsI,deltaM,.False.,gTFd,gPFd(:,10:144),BRFd(:,10:144))

End If 
Do i1=1,3
gTFd(i1) =Sum(gPFd(i1,:)) 
If (gTFd(i1).Gt.0._dp) BRFd(i1,: ) =gPFd(i1,:)/gTFd(i1) 
End Do 
 

gPhh = 0._dp 
gThh = 0._dp 
BRhh = 0._dp 
Call hhTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,           & 
& MHI0,MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,            & 
& ZDL,ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,              & 
& Yd,Ye,MS2,M12,M22,v,gPhh,gThh,BRhh)

gPss = 0._dp 
gTss = 0._dp 
BRss = 0._dp 
Call ssTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,Mhh2,           & 
& MHI0,MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,            & 
& ZDL,ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu,              & 
& Yd,Ye,MS2,M12,M22,v,gPss,gTss,BRss)

gPHI0 = 0._dp 
gTHI0 = 0._dp 
BRHI0 = 0._dp 
Call HI0TwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,               & 
& Mhh2,MHI0,MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,               & 
& ZER,ZUR,ZDL,ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,               & 
& L4,L2,Yu,Yd,Ye,MS2,M12,M22,v,gPHI0,gTHI0,BRHI0)

gPHIp = 0._dp 
gTHIp = 0._dp 
BRHIp = 0._dp 
Call HIpTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,Mhh,               & 
& Mhh2,MHI0,MHI02,MHIp,MHIp2,MHp,MHp2,Mss,Mss2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,               & 
& ZER,ZUR,ZDL,ZEL,ZUL,ZW,ZZ,g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,               & 
& L4,L2,Yu,Yd,Ye,MS2,M12,M22,v,gPHIp,gTHIp,BRHIp)

Iname = Iname - 1 
 
End Subroutine CalculateBR 
End Module BranchingRatios_SDDM 
 