! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.6.0 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 15:43 on 18.11.2015   
! ----------------------------------------------------------------------  
 
 
Module Tadpoles_SDDM 
 
Use Model_Data_SDDM 
Use SUSYMasses_SDDM 
Use RGEs_SDDM 
Use Control 

Use Mathematics 

Contains 


Subroutine SolveTadpoleEquations(g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,              & 
& Lam,L3,L4,L2,Yu,Yd,Ye,MS2,M12,M22,v,Tad1Loop)

Implicit None
Real(dp),Intent(inout) :: g1,g2,g3,v

Complex(dp),Intent(inout) :: LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu(3,3),Yd(3,3),Ye(3,3),MS2,M12,M22

Complex(dp), Intent(in) :: Tad1Loop(1)

! For numerical routines 
Real(dp) :: gC(86)
logical :: broycheck 
Real(dp) :: broyx(1)

If (HighScaleModel.Eq."LOW") Then 
M12 = -(Lam*v**2)/2._dp + Tad1Loop(1)/v

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (Real(M12,dp).ne.Real(M12,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for M12" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(M12)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for M12" 
   !Call TerminateProgram  
   M12 = Real(M12,dp) 
  SignOfMuChanged= .True. 
End If 
 Else 
M12 = -(Lam*v**2)/2._dp + Tad1Loop(1)/v

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (Real(M12,dp).ne.Real(M12,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for M12" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(M12)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for M12" 
   !Call TerminateProgram  
   M12 = Real(M12,dp) 
  SignOfMuChanged= .True. 
End If 
 End if 
End Subroutine SolveTadpoleEquations

Subroutine CalculateTadpoles(g1,g2,g3,LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,              & 
& L3,L4,L2,Yu,Yd,Ye,MS2,M12,M22,v,Tad1Loop,TadpoleValues)

Real(dp),Intent(in) :: g1,g2,g3,v

Complex(dp),Intent(in) :: LS4,LS12,LS21,L5,LS4c,LS1,LS2,Lam,L3,L4,L2,Yu(3,3),Yd(3,3),Ye(3,3),MS2,M12,M22

Complex(dp), Intent(in) :: Tad1Loop(1)

Real(dp), Intent(out) :: TadpoleValues(1)

TadpoleValues(1) = Real(M12*v + (Lam*v**3)/2._dp - Tad1Loop(1),dp) 
End Subroutine CalculateTadpoles 

End Module Tadpoles_SDDM 
 
